/*!
 * \file      board-config.h
 *
 * \brief     Board configuration
 *
 * \copyright Revised BSD License, see section \ref LICENSE.
 *
 * \code
 *                ______                              _
 *               / _____)             _              | |
 *              ( (____  _____ ____ _| |_ _____  ____| |__
 *               \____ \| ___ |    (_   _) ___ |/ ___)  _ \
 *               _____) ) ____| | | || |_| ____( (___| | | |
 *              (______/|_____)_|_|_| \__)_____)\____)_| |_|
 *              (C)2013-2017 Semtech
 *
 *               ___ _____ _   ___ _  _____ ___  ___  ___ ___
 *              / __|_   _/_\ / __| |/ / __/ _ \| _ \/ __| __|
 *              \__ \ | |/ _ \ (__| ' <| _| (_) |   / (__| _|
 *              |___/ |_/_/ \_\___|_|\_\_| \___/|_|_\\___|___|
 *              embedded.connectivity.solutions===============
 *
 * \endcode
 *
 * \author    Miguel Luis ( Semtech )
 *
 * \author    Gregory Cristian ( Semtech )
 *
 * \author    Daniel Jaeckle ( STACKFORCE )
 *
 * \author    Johannes Bruder ( STACKFORCE )
 */
#ifndef __BOARD_CONFIG_H__
#define __BOARD_CONFIG_H__

#ifdef __cplusplus
extern "C"
{
#endif

/*!
 * Defines the time required for the TCXO to wakeup [ms].
 */
#define BOARD_TCXO_WAKEUP_TIME                      5

/*!
 * Board MCU pins definitions
 */
// #define RADIO_RESET                                 15

// #define RADIO_MOSI                                  11
// #define RADIO_MISO                                  12
// #define RADIO_SCLK                                  10

// #define RADIO_NSS                                   3
// #define RADIO_BUSY                                  2
// #define RADIO_DIO_1                                 20

// #define RADIO_ANT_SWITCH_POWER                      22

// RP2040-LoRa
#define RADIO_RESET                                 23

#define RADIO_MOSI                                  15
#define RADIO_MISO                                  24
#define RADIO_SCLK                                  14

#define RADIO_NSS                                   13
#define RADIO_BUSY                                  18
#define RADIO_DIO_1                                 16

#define RADIO_ANT_SWITCH_POWER                      17

#ifdef __cplusplus
}
#endif

#endif // __BOARD_CONFIG_H__
